# About

This is a repository of Haskell Jupyter notebooks which will mostly notes on
Optics and my exploration in Optics through various blog posts and also
primarily driven by Chris Penner's book Optics by example.

# Installing IHaskell

Sorry, I assume Nix here as it was just easy.

```
git clone https://github.com/gibiansky/IHaskell.git
nix-build release.nix --argstr compiler ghc865 --arg packages "haskellPackages: [ haskellPackages.lens ]"
result/bin/ihaskell-notebook
```
One can link the binary in local/bin to the above so that it can be run from
anywhere.

# My Lens talk

https://www.youtube.com/watch?v=uZLN2x3u2kg

# References

namc.in/2018-03-26-lenses-part-1

https://deontologician.com/wiki/lenses/

https://www.schoolofhaskell.com/user/griba/easier_lenses_profunctor_based_with_mezzolens

https://www.schoolofhaskell.com/user/liyang/profunctors

https://bartoszmilewski.com/2015/07/13/from-lenses-to-yoneda-embedding/

https://github.com/hablapps/DontFearTheProfunctorOptics

https://twanvl.nl/blog/haskell/isomorphism-lenses

https://blog.jez.io/lens-intuition/

https://blog.jle.im/entry/lenses-products-prisms-sums.html

http://oleg.fi/gists/posts/2017-04-18-glassery.html

https://www.seas.upenn.edu/~cis194/fall16/lectures/14-lenses.html

